#include "pntrs.h"

extern int debug;

extern int compar( char *, char * );

char **
bin_search( char **p_pntr, char *name, int insert )
{
	register int i;
	char object[INBUF];
	char *p, *q;
	char **low, **mid, **top;
	int found;

	p = object;
	q = name;
	while( *q && *q != ' ' && *q != '\t' && *q != '\n' )
		*p++ = *q++;
	*p = '\0';

	low = p_pntr;
	for( top = low; *top != NULL; top++ );
	top--;
	mid = low + (( top - low ) >> 1 );

#ifdef DEBUG
	if( debug > 3 ) {
		fprintf( stderr, "bin_search: >%s<\n", name );
		fprintf( stderr, "\tlow 0x%07x, mid 0x%07x, top 0x%07x\n",
				  (int)low, (int)mid, (int)top );
	}
#endif	/* DEBUG */

	found = 0;
	while( 1 ) {
		p = object;
		q = *mid;
		if( debug > 5 ) {
			while (*q != ' ' && *q != '\n' && *q)
				q++;
			i = q - *mid;
			q = *mid;
			fprintf( stderr, "    object: >%.*s<\n", i, q );
		}
		if(( i = compar(p, q)) == 0 ) {
			found = 1;
			break;
		}
		if( i < 0 ) {
			top = mid;
			mid = low + ((mid - low) >> 1 );
			if( mid == low )
				break;
		} else if( i > 0 ) {
			low = mid;
			mid = top - ((top - mid) >> 1 );
			if( mid == top )
				break;
		}
	}
	if( compar( object, *mid ) == 0 )
			found = 1;
	return(( insert ^ found ) ? mid : (char **)0 );
}
