#include "pntrs.h"

extern int debug;

extern int add_on( struct p_pntrs *, char * );
extern int compar( char *, char * );
extern char **bin_search( char **, char *, int );

int
insert( struct p_pntrs *pntrs, char *data )
{
	char **pp, **qq, **rr;
	char *p;
	int position;

	if( debug > 2 )
		fprintf(stderr, "insert: data = >%s<.\n", data);

	/* The trivial condition for the first data to be inserted. */
	if( pntrs->pp_cnt == 0 ) {
		if( add_on( pntrs, data ) < 0 )
			return( -1 );
		return( 1 );
	}
	/* Another trivial condition with only one entry. */
	if (pntrs->pp_cnt == 1) {
		if( compar( *(pntrs->pp_pntr), data ) == 0 ) pp = NULL;
		else pp = pntrs->pp_pntr + 1;
	}
	/* No longer trivial, call 'bin_search()' with the 'insert' flag set. */
	else pp = bin_search( pntrs->pp_pntr, data, 1 );

	/* pp will point to the location the pointer should be inserted */
	if ( pp != NULL ) {
		position = pp - pntrs->pp_pntr;
		if( add_on( pntrs, data ) < 0 )
			return( -1 );
		/* pntrs->pp_pntr may get changed by add_on() if realloced */
		pp = pntrs->pp_pntr + position;
		qq = pntrs->pp_pntr + ( pntrs->pp_cnt - 1 );
		rr = qq - 1;
		if( rr < pntrs->pp_pntr ) rr = pntrs->pp_pntr;
		if( compar( *rr, *qq ) > 0 ) {
			while( pp > pntrs->pp_pntr && compar( *pp, data ) > 0 )
				pp--;
			while( pp <= rr && compar( *pp, data ) < 0 )
				pp++;
			p = *qq;
			while( rr >= pp ) {
				*qq = *rr;
				qq--; rr--;
			}
			*pp = p;
		}
		return( 1 );
	}
	return( 0 );
}
